#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#include "Construcao.h"
#include "Util.h"
#include "Descida.h"
#include "VNS.h"

float VNS(int n, int *s, float **d, int VNS_max, int r){
   int *s_duas_linhas,
       iter = 0,
       k;
   float fo,
       fo_duas_linhas;

   s_duas_linhas = cria_vetor(n);
   fo = calcula_fo(n,s,d);
   printf("Iteracao VNS = %3d \t  fo_star = %10.4f \n",iter,fo);
   while (iter < VNS_max){
     iter++;
     k = 1;
     while (k <= r){
       // Escolher vizinho s' qualquer na k-esima vizinhanca de s
       atualiza_vetor(s_duas_linhas,s,n);
       fo_duas_linhas = gera_k_vizinhos_aleatorios(n,s_duas_linhas,d,fo,k);
       fo_duas_linhas = descida(n,s_duas_linhas,d);
       if (fo_duas_linhas < fo){
         fo = fo_duas_linhas;
         atualiza_vetor(s, s_duas_linhas, n);
         printf("Iteracao VNS = %3d \t  fo_star = %10.4f \n",iter,fo);
         k = 1;
       }
       else
         k++;
     }
   }
   libera_vetor(s_duas_linhas);
   return fo;
}



float gera_um_vizinho_aleatorio(int n,
                                int *s,
                                float **d,
                                float fo)
{
  int i,j,aux;
  float fo_viz;

  i = random(n);
  do{
    j = random(n);
  } while(i == j);
  float delta1 = calcula_delta(n,s,d,i,j);

  aux = s[i];
  s[i] = s[j];
  s[j] = aux;
  float delta2 = calcula_delta(n,s,d,i,j);
  fo_viz = fo - delta1 + delta2;
  return fo_viz;
}


float gera_k_vizinhos_aleatorios(int n,
                                 int *s,
                                 float **d,
                                 float fo,
                                 int k)
{
  float fo_viz;
  for (int i=0; i<k; i++)
    fo_viz = gera_um_vizinho_aleatorio(n,s,d,fo);

  return fo_viz;

}//gera_vizinho
